from iterated_functions import IteratedFunctionSystem


def make_affine(a, b, c, d, e, f):
    def func(x, y):
        return a * x + b * y + e, c * x + d * y + f
    return func


table = [
    (0,           0.053,       -0.429,       0,            -7.083,    5.43),
    (0.143,       0,           0,            -0.053,       -5.619,    8.513),
    (0.143,       0,           0,            0.083,        -5.619,    2.057),
    (0,           0.053,       0.429,        0,            -3.952,    5.43),
    (0.119,       0,           0,            0.053,        -2.555,    4.536),
    (-0.0123806,  -0.0649723,  0.423819,     0.00189797,   -1.226,    5.235),
    (0.0852291,   0.0506328,   0.420449,     0.0156626,    -0.421,    4.569),
    (0.104432,    0.00529117,  0.0570516,    0.0527352,    0.976,     8.113),
    (-0.00814186, -0.0417935,  0.423922,     0.00415972,   1.934,     5.37),
    (0.093,       0,           0,            0.053,        0.861,     4.536),
    (0,           0.053,       -0.429,       0,            2.447,     5.43),
    (0.119,       0,           0,            -0.053,       3.363,     8.513),
    (0.119,       0,           0,            0.053,        3.363,     1.487),
    (0,           0.053,       0.429,        0,            3.972,     4.569),
    (0.123998,    -0.00183957, 0.000691208,  0.0629731,    6.275,     7.716),
    (0,           0.053,       0.167,        0,            5.215,     6.483),
    (0.071,       0,           0,            0.053,        6.279,     5.298),
    (0,           -0.053,      -0.238,       0,            6.805,     3.714),
    (-0.121,      0,           0,            0.053,        5.941,     1.487),
]


def test_chaos():
    fcs = [make_affine(a, b, c, d, e, f) for a, b, c, d, e, f in table]
    # fcs = [make_affine(*data) for data in table]
    probs = [1 / len(fcs)] * len(fcs)
    fractal = IteratedFunctionSystem(fcs, probs, (0, 0))
    for i in [1000, 10000, 1000000]:
        fractal.draw(i)


if __name__ == "__main__":
    test_chaos()
